/*
 * Copyright 1999 Usaf Aladl <ualadl@julian.uwo.ca>
 *
 * This program is free software. You can use, copy and modify it under
 * the terms of the GPL. See the file COPYING for the full GPL license.
*/

#include <stdio.h>
#include <sys/stat.h>
#include <gtk/gtk.h>
#include "gtkrtext.h"
#include "pixmaps.h"

#define DWINDOWWIDTH	600
#define DWINDOWHIGHT	420
#define DXWIN		10
#define DYWIN		10

void CreateGUI();
void CloseApplicationCB(GtkWidget *widget, gpointer data);
void FileModifiedCB( GtkWidget *widget, gpointer data );
void get_main_menu(GtkWidget *window, GtkWidget ** menubar);
void NewWindowCB( GtkWidget *widget, gpointer data );
void OpenFileCB( GtkWidget *widget, gpointer data );
void CloseFileCB( GtkWidget *widget, gpointer data );
void SaveFileCB( GtkWidget *widget, gpointer data );
void SavasFileCB( GtkWidget *widget, gpointer data );
void BGColorCB( GtkWidget *widget, gpointer data );
void FGColorCB( GtkWidget *widget, gpointer data );
void PrintFileCB( GtkWidget *widget, gpointer data );
void PrintFileOkCB( GtkWidget *widget, gpointer data );
void PrintFileCancelCB( GtkWidget *widget, gpointer data );
void PrintArabTexCB( GtkWidget *widget, gpointer data );
void PrintPrinterCB( GtkWidget *widget, gpointer data );
void PrintPostscriptCB( GtkWidget *widget, gpointer data );
void SelectFontShell(GtkWidget * w, gpointer data);
void FontSelectionOkCB(GtkWidget * w, GtkWidget *text);
void FontSelectCancelCB( GtkWidget *widget, gpointer data );
void FileSelectShell(GtkWidget *fileselect);
void FileSelectionOkCB(GtkWidget * w, GtkFileSelection *fs);
gint OpenFile(GtkWidget *text, gchar *fname);
void BGColorSelectShell();
void BGColorChangedCB(GtkWidget *widget,gpointer data); 
void FGColorSelectShell();
void FGColorChangedCB(GtkWidget *widget,gpointer data); 
void ChangeColorCancelCB( GtkWidget *widget, gpointer data );
void MyBoard(gchar*);
void MyBoardCB( GtkWidget *widget, gpointer data );
void SaveAsOkCB( GtkWidget *widget, GtkFileSelection *fs );
void SaveAsCancelCB( GtkWidget *widget, gpointer data );
void CleanTextBuffer();
void CloseMakeSureDialog();
void SaveDialogCB(GtkWidget *widget, gpointer data);
void DontSaveDialogCB(GtkWidget *widget, gpointer data);
void CancelDialogCB(GtkWidget *widget, gpointer data);
void QuitMakeSureDialog();
void QSaveDialogCB(GtkWidget *widget, gpointer data);
void QDontSaveDialogCB(GtkWidget *widget, gpointer data);
void QCancelDialogCB(GtkWidget *widget, gpointer data);
void AboutCB(GtkWidget *widget, gpointer data);
void AboutCancelCB(GtkWidget *widget, gpointer data);
void CreateKeyboardCB( GtkWidget *widget, gpointer data );
void KeyBoard(GtkWidget *w);
void KeyboardDismisCB(GtkWidget *widget, gpointer data);
void PrintKeyboard (GtkWidget *widget, gchar* data);
GtkStyle *NewStyle (GdkFont *f);
void SetStyleRecursively (GtkWidget *widget, gpointer data);
void Right2LeftCB( GtkWidget *widget, gpointer data );
void Left2RightCB( GtkWidget *widget, gpointer data );

GtkWidget       *kbbox;
GtkWidget       *rows[6];
GtkWidget       *keys[255];
GtkWidget       *keywin;
static gchar     ch[255][2];

GtkWidget       *window;
GtkWidget       *mainbox;
GtkWidget       *menubar;
GtkWidget       *toolbarbox;
GtkWidget       *toolbar;
GtkWidget       *textbox;
GtkWidget       *texttable;
GtkWidget       *text;
GtkWidget       *vscrollbar;
GtkWidget       *fontdialog;
GtkWidget       *fileselect;
GtkWidget  	*colorseld;
GtkWidget  	*colorsel;
GtkWidget       *winboard;
GtkWidget       *label;
GtkWidget       *button;
GtkWidget       *winsave;
GtkWidget       *aboutwin;
GtkWidget 	*printwin;
GtkWidget 	*printentry;
int             windowWidth;
int             windowHight;
int             xwin;
int             ywin;
GdkColor        colorfg;
GdkColor        colorbg;
static GdkFont         *font;
gchar           filename[1000];
gboolean        FileModified;
char            myfont[]="*-iso8859-1";
GdkPixmap 	*icon;
GdkBitmap 	*mask;
GtkWidget 	*iconw;
GtkStyle        *style;
GdkColormap 	*cmap;
GdkColor 	colorfg;
GdkColor 	colorbg;

gchar 		progname[128];
gchar		strbus[524];
char            windowTitle[128];

gint		x;
gint		y;
char		DefFileName[]="Unknow file name";
gint		PrinterFlage;
static GtkItemFactoryEntry menu_items[] = {
  {"/File",          NULL,         NULL, 0, "<Branch>"},
  {"/File/tearoff",  NULL,   0,    0,   "<Tearoff>"},
  {"/File/New",      NULL,   	   NewWindowCB, 0, NULL},
  {"/File/sep1",     NULL,         NULL, 0, "<Separator>"},
  {"/File/_Open",    "<control>O", OpenFileCB, 0, NULL},
  {"/File/sep1",     NULL,         NULL, 0, "<Separator>"},
  {"/File/_Close",    "<control>C",CloseFileCB, 0, NULL},
  {"/File/sep1",     NULL,         NULL, 0, "<Separator>"},
  {"/File/_Save",    "<control>S", SaveFileCB, 0, NULL},
  {"/File/sep1",     NULL,         NULL, 0, "<Separator>"},
  {"/File/Save _As", NULL,         SavasFileCB, 0, NULL},
  {"/File/sep1",     NULL,         NULL, 0, "<Separator>"},
  {"/File/Print",    NULL,         PrintFileCB, 0, NULL},
  {"/File/sep1",     NULL,         NULL, 0, "<Separator>"},
  {"/File/Quit",     "<control>Q", CloseApplicationCB, 0, NULL},
  {"/Tools",         NULL,         NULL, 0, "<Branch>"},
  {"/Tools/tearoff",  NULL,   0,    0,   "<Tearoff>"},
  {"/Tools/Keyboard",  NULL,      CreateKeyboardCB, 0, NULL},
  {"/Options",        NULL,         NULL, 0, "<Branch>"},
  {"/Options/tearoff",  NULL,   0,    0,   "<Tearoff>"},
  {"/Options/Font",    NULL,         SelectFontShell, 0, NULL},
  {"/Options/sep1",     NULL,         NULL, 0, "<Separator>"},
  {"/Options/BGColor",  NULL,      BGColorCB, 0, NULL},
  {"/Options/sep1",     NULL,         NULL, 0, "<Separator>"},
  {"/Options/FGColor",  NULL,      FGColorCB, 0, NULL},
  {"/Options/sep1",     NULL,         NULL, 0, "<Separator>"},
  {"/Options/Right To Left",    NULL, Right2LeftCB , 1, "<RadioItem>"},
  {"/Options/Left To Right",   NULL, Left2RightCB, 2, "/Options/Right To Left"},
  {"/_Help",         	NULL,         NULL, 0, "<LastBranch>"},
  {"/_Help/About",   	NULL,         AboutCB, 0, NULL},
};
/*******************************************************/
int main (int argc, char *argv[])
{
windowWidth=DWINDOWWIDTH;
windowHight=DWINDOWHIGHT ;
xwin=DXWIN;
ywin=DYWIN;
FileModified=FALSE;
strncpy(progname, argv[0], 100);
strncpy(windowTitle, argv[0], 100);
strcpy(filename,DefFileName);
gtk_init (&argc, &argv);
CreateGUI();
gtk_widget_show (window);

if(argv[1]!=NULL)
{
strcpy(filename,argv[1]);
OpenFile(text,filename);
}

gtk_main ();
return(0);
}
/**************************************************/
void CreateGUI()
{
/* create the main window */
window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
gtk_widget_set_usize(window,windowWidth,windowHight);
gtk_window_set_policy(GTK_WINDOW(window),FALSE,TRUE,TRUE);
gtk_signal_connect(GTK_OBJECT(window),"destroy",
                   GTK_SIGNAL_FUNC(CloseApplicationCB),NULL);
gtk_signal_connect(GTK_OBJECT (window), "delete_event",
                   GTK_SIGNAL_FUNC (CloseApplicationCB), NULL);
gtk_window_set_title (GTK_WINDOW (window),windowTitle);
gtk_widget_set_uposition (window,xwin,ywin);
gtk_container_set_border_width (GTK_CONTAINER(window), 0);
/***************************************************/
mainbox= gtk_vbox_new (FALSE, 0);
gtk_container_add (GTK_CONTAINER (window), mainbox);
gtk_container_border_width (GTK_CONTAINER (mainbox), 2);
gtk_widget_show (mainbox);
/***************************************************/
get_main_menu(window, &menubar);
gtk_box_pack_start(GTK_BOX(mainbox), menubar, FALSE, TRUE, 2);
gtk_widget_show(menubar);
/***************************************************/
toolbarbox= gtk_handle_box_new ();
gtk_box_pack_start(GTK_BOX(mainbox),toolbarbox,FALSE,TRUE,2);
gtk_widget_show (toolbarbox);
/***************************************************/
toolbar=gtk_toolbar_new( GTK_ORIENTATION_HORIZONTAL,
                              GTK_TOOLBAR_BOTH );
gtk_container_border_width (GTK_CONTAINER (toolbar ) , 2 );
gtk_toolbar_set_space_size (GTK_TOOLBAR ( toolbar ),5 );
gtk_toolbar_set_button_relief (GTK_TOOLBAR (toolbar), GTK_RELIEF_NONE);
gtk_container_add ( GTK_CONTAINER(toolbarbox ) , toolbar );
gtk_widget_show(toolbar);
/***************************************************/
gtk_widget_realize (window );
/***************************************************/
icon = gdk_pixmap_create_from_xpm_d (window->window, &mask,
              &window->style->white, new_xpm );
iconw = gtk_pixmap_new (icon, mask );
 gtk_toolbar_append_item ( GTK_TOOLBAR(toolbar), 
                     "New",               
                     "New window",     
                     "Private",       
                     iconw,          
                     GTK_SIGNAL_FUNC(NewWindowCB), 
                                                NULL );
gtk_toolbar_append_space ( GTK_TOOLBAR (toolbar ) ); 
/***************************************************/
icon = gdk_pixmap_create_from_xpm_d (window->window, &mask,
              &window->style->white, open_xpm );
iconw = gtk_pixmap_new (icon, mask );
 gtk_toolbar_append_item ( GTK_TOOLBAR(toolbar),
                     "Open",              
                     "Open file",     
                     "Private",        
                     iconw,           
                     GTK_SIGNAL_FUNC(OpenFileCB), 
                                                NULL );

gtk_toolbar_append_space ( GTK_TOOLBAR (toolbar ) ); 
/***************************************************/
icon = gdk_pixmap_create_from_xpm_d (window->window, &mask,
              &window->style->white, close_xpm );
iconw = gtk_pixmap_new (icon, mask );
 gtk_toolbar_append_item ( GTK_TOOLBAR(toolbar), 
                     "Close",               
                     "Close file",     
                     "Private",             
                     iconw,                
                     GTK_SIGNAL_FUNC(CloseFileCB), 
                                                NULL );

gtk_toolbar_append_space ( GTK_TOOLBAR (toolbar ) ); 
/***************************************************/
icon = gdk_pixmap_create_from_xpm_d (window->window, &mask,
              &window->style->white, save_xpm );
iconw = gtk_pixmap_new (icon, mask );
gtk_toolbar_append_item ( GTK_TOOLBAR(toolbar), 
                     "Save",               
                     "Save file",     
                     "Private",             
                     iconw,                
                     GTK_SIGNAL_FUNC(SaveFileCB), 
                                                NULL );

gtk_toolbar_append_space ( GTK_TOOLBAR (toolbar ) ); 
/***************************************************/
icon = gdk_pixmap_create_from_xpm_d (window->window, &mask,
              &window->style->white, print_xpm );
iconw = gtk_pixmap_new (icon, mask );
gtk_toolbar_append_item ( GTK_TOOLBAR(toolbar), 
                     "Print",               
                     "Print file",     
                     "Private",       
                     iconw,                 
                     GTK_SIGNAL_FUNC(PrintFileCB), 
                                                NULL );

gtk_toolbar_append_space ( GTK_TOOLBAR (toolbar ) ); 
/***************************************************/
textbox = gtk_vbox_new (FALSE, 5);
gtk_container_set_border_width (GTK_CONTAINER (textbox), 5);
gtk_box_pack_start (GTK_BOX (mainbox), textbox, TRUE, TRUE, 0);
gtk_widget_show (textbox);
/***************************************************/
texttable = gtk_table_new (2, 2, FALSE);
gtk_table_set_row_spacing (GTK_TABLE (texttable), 0, 2);
gtk_table_set_col_spacing (GTK_TABLE (texttable), 0, 2);
gtk_box_pack_start (GTK_BOX (textbox), texttable, TRUE, TRUE, 0);
gtk_widget_show (texttable);
/***************************************************/
/* Create the GtkText widget */
text = gtk_rtext_new (NULL, NULL);
gtk_rtext_set_editable (GTK_RTEXT (text), TRUE);
gtk_signal_connect(GTK_OBJECT(text),"changed",
                   GTK_SIGNAL_FUNC(FileModifiedCB),NULL);
gtk_table_attach (GTK_TABLE (texttable), text, 0, 1, 0, 1,
                    GTK_EXPAND | GTK_SHRINK | GTK_FILL,
                    GTK_EXPAND | GTK_SHRINK | GTK_FILL, 0, 0);
gtk_widget_show (text);
/***************************************************/
/* Add a vertical scrollbar to the GtkRtext widget */
vscrollbar=gtk_vscrollbar_new (GTK_RTEXT (text)->vadj);
gtk_table_attach(GTK_TABLE (texttable), vscrollbar, 1, 2, 0, 1,
            GTK_FILL, GTK_EXPAND | GTK_SHRINK | GTK_FILL, 0, 0);
gtk_widget_show(vscrollbar);
/***************************************************/
font = gdk_font_load (myfont);
gtk_widget_realize(text);
/***************************************************/
 cmap = gdk_colormap_get_system();
 colorfg.red = 0;
 colorfg.green = 0xffff;
 colorfg.blue = 0;
 if (!gdk_color_alloc(cmap, &colorfg)) {
   g_error("couldn't allocate color");
 }
 colorbg.red = 0;
 colorbg.green = 0;
 colorbg.blue = 0;
 if (!gdk_color_alloc(cmap, &colorbg)) {
   g_error("couldn't allocate color");
 }

/***************************************************/
gtk_rtext_freeze (GTK_RTEXT (text));
style = gtk_style_copy(gtk_widget_get_style (text));
gdk_font_unref (style->font);
style->font = font;
style->text[GTK_STATE_NORMAL]=colorfg;
style->base[GTK_STATE_NORMAL]=colorbg;
gdk_font_ref (style->font);
gtk_widget_set_style (text, style);
 gtk_rtext_thaw (GTK_RTEXT (text));

}
/**************************************************/
void CloseApplicationCB( GtkWidget *widget, gpointer data )
{
if(FileModified==TRUE){
QuitMakeSureDialog();
return;
}
gtk_main_quit();
}
/**************************************************/
void FileModifiedCB( GtkWidget *widget, gpointer data )
{
if(FileModified==FALSE)
FileModified=TRUE;
}
/**************************************************/
void NewWindowCB( GtkWidget *widget, gpointer data )
{
 sprintf(strbus, "%s &", progname);
 system(strbus);
}
/**************************************************/
void PrintFileCB( GtkWidget *widget, gpointer data )
{
MyBoard("Sorry, It is not implemented yet");    
}

/**************************************************/
/*
void PrintFileCB( GtkWidget *widget, gpointer data )
{
GtkWidget *printbutton;
GtkWidget *printbox;
GSList *printgroup;

if(printwin!=NULL)gtk_widget_destroy(printwin);
printwin=gtk_dialog_new();

gtk_signal_connect (GTK_OBJECT (printwin), "destroy",
GTK_SIGNAL_FUNC(PrintFileCancelCB), printwin);

gtk_signal_connect (GTK_OBJECT (printwin), "delete_event",
GTK_SIGNAL_FUNC(PrintFileCancelCB), printwin);

gtk_window_set_title (GTK_WINDOW (printwin), "Print File");
gtk_container_border_width (GTK_CONTAINER (printwin), 2);
gdk_window_get_origin (window->window,&x,&y);
gtk_widget_set_uposition (printwin, x, y);
gtk_widget_realize(printwin);

printbutton = gtk_radio_button_new_with_label (NULL, "Postscript File");
gtk_box_pack_start (GTK_BOX (GTK_DIALOG (printwin)->vbox),
			 printbutton, TRUE, TRUE, 0);
gtk_signal_connect( GTK_OBJECT(printbutton  ), "clicked",
                            GTK_SIGNAL_FUNC(PrintPostscriptCB), NULL );

gtk_widget_show (printbutton);
printgroup=gtk_radio_button_group (GTK_RADIO_BUTTON (printbutton));

printbutton = gtk_radio_button_new_with_label (printgroup, "ArabTex File");
gtk_box_pack_start (GTK_BOX (GTK_DIALOG (printwin)->vbox),
                         printbutton, TRUE, TRUE, 0);
gtk_signal_connect( GTK_OBJECT(printbutton  ), "clicked",
                            GTK_SIGNAL_FUNC(PrintArabTexCB), NULL );


gtk_widget_show (printbutton);

printbutton = gtk_radio_button_new_with_label(
gtk_radio_button_group (GTK_RADIO_BUTTON (printbutton)),
"Printer");

gtk_toggle_button_set_state (GTK_TOGGLE_BUTTON (printbutton), TRUE);
PrinterFlage=3;
gtk_box_pack_start (GTK_BOX (GTK_DIALOG (printwin)->vbox),
                         printbutton, TRUE, TRUE, 0);
gtk_signal_connect( GTK_OBJECT(printbutton  ), "clicked",
                            GTK_SIGNAL_FUNC(PrintPrinterCB), NULL );


gtk_widget_show (printbutton);
printbox=gtk_hbox_new(FALSE,0);
gtk_box_pack_start (GTK_BOX (GTK_DIALOG (printwin)->vbox),
                         printbox, TRUE, TRUE, 0);
gtk_widget_show (printbox);

printentry = gtk_entry_new_with_max_length (255);
gtk_box_pack_start (GTK_BOX (printbox), printentry, FALSE, TRUE, 10);
gtk_widget_show (printentry);

printbutton = gtk_button_new_with_label ("  Browse ");
gtk_box_pack_start (GTK_BOX (printbox), printbutton, TRUE, TRUE, 0);
gtk_widget_show (printbutton);

printbutton = gtk_button_new_with_label ("   Ok   ");
gtk_signal_connect_object (GTK_OBJECT (printbutton), "clicked",
GTK_SIGNAL_FUNC(PrintFileOkCB), GTK_OBJECT (printwin));
gtk_box_pack_start (GTK_BOX (GTK_DIALOG (printwin)->action_area),
  printbutton, TRUE, TRUE, 0);
gtk_widget_show (printbutton);

printbutton = gtk_button_new_with_label (" Cancel  ");
gtk_signal_connect_object (GTK_OBJECT (printbutton), "clicked",
GTK_SIGNAL_FUNC(PrintFileCancelCB), GTK_OBJECT (printwin));
gtk_box_pack_start (GTK_BOX (GTK_DIALOG (printwin)->action_area),
printbutton, TRUE, TRUE, 0);
gtk_widget_show (printbutton);


gtk_widget_show (printbutton);
gtk_widget_show (printwin);
gtk_widget_set_sensitive(GTK_WIDGET(printentry) , FALSE );
}
*/
/**************************************/
void PrintFileCancelCB( GtkWidget *widget, gpointer data )
{
gtk_widget_destroy(printwin);
printwin=NULL;
return;
}
/***************************************/
void PrintFileOkCB( GtkWidget *widget, gpointer data )
{

	switch(PrinterFlage){

		case 1:		/*postscript*/
		{
printf("postscript\n");
		
			break;
		} 
		case 2:         /* ArabTex */
		{
printf(" ArabTex \n");

			break;
		}
		case 3:         /* printer */   
		{
printf(" printer\n");

			break;
		}
		default:
		{
			break;
		}
	}	
gtk_widget_destroy(printwin);
printwin=NULL;
return;
}

/**************************************/
void PrintPostscriptCB( GtkWidget *widget, gpointer data )
{
PrinterFlage=1;
gtk_widget_set_sensitive(GTK_WIDGET(printentry) , TRUE );
return;
}
/***************************************/
void PrintArabTexCB( GtkWidget *widget, gpointer data )
{
PrinterFlage=2;
gtk_widget_set_sensitive(GTK_WIDGET(printentry), TRUE );
return;
}
/***************************************/
void PrintPrinterCB( GtkWidget *widget, gpointer data )
{
PrinterFlage=3;
gtk_widget_set_sensitive(GTK_WIDGET(printentry) , FALSE );
return;
}
/**************************************************/
void OpenFileCB( GtkWidget *widget, gpointer data )
{
      FileSelectShell(fileselect);
}
/**************************************************/
void CloseFileCB( GtkWidget *widget, gpointer data )
{
if(FileModified==TRUE){
CloseMakeSureDialog();
}else{
CleanTextBuffer();
FileModified=FALSE;
strcpy(filename,DefFileName);
}
}
/**************************************************/
void SaveFileCB( GtkWidget *widget, gpointer data )
{
FILE	*fd;
char* tempstr;
if(strcmp(filename,DefFileName)==0){
 SavasFileCB(window, (gpointer)NULL);
 return;
 }
tempstr=gtk_editable_get_chars(GTK_EDITABLE (text), 0,
                 gtk_rtext_get_length(GTK_RTEXT(text)));
fd=fopen(filename,"w");
if(fd==NULL){
MyBoard("Saving failed\nCan't open file for writing");
g_free(tempstr);
return;
}

fputs((char *)tempstr,fd);
if(fd!=NULL) fclose(fd);
FileModified =FALSE ;
g_free(tempstr);
}
/**************************************************/
void SavasFileCB( GtkWidget *widget, gpointer data )
{
gdk_window_get_origin (window->window,&x,&y);
 if(winsave!=NULL){
  gtk_widget_destroy(winsave);
 }
winsave = gtk_file_selection_new ("Save file");
gtk_signal_connect (GTK_OBJECT (winsave), "destroy",
GTK_SIGNAL_FUNC(SaveAsCancelCB), winsave);
gtk_signal_connect (GTK_OBJECT (winsave), "delete_event",
GTK_SIGNAL_FUNC(SaveAsCancelCB), winsave);
gtk_signal_connect (GTK_OBJECT (GTK_FILE_SELECTION(winsave)->ok_button),
  "clicked", GTK_SIGNAL_FUNC(SaveAsOkCB), winsave);
gtk_signal_connect(GTK_OBJECT(GTK_FILE_SELECTION(winsave)->cancel_button),
  "clicked", GTK_SIGNAL_FUNC(SaveAsCancelCB), winsave);
gtk_widget_set_uposition (winsave, x, y);
gtk_widget_show (winsave);
}
/**************************************************/
void BGColorCB( GtkWidget *widget, gpointer data )
{
BGColorSelectShell();
}
/**************************************************/
void FGColorCB( GtkWidget *widget, gpointer data )
{
FGColorSelectShell();
}
/**************************************************/
void get_main_menu(GtkWidget *window, GtkWidget ** menubar)
{
  int nmenu_items = sizeof(menu_items) / sizeof(menu_items[0]);
  GtkItemFactory *item_factory;
  GtkAccelGroup *accel_group;

  accel_group=gtk_accel_group_new();
  item_factory = gtk_item_factory_new(GTK_TYPE_MENU_BAR, "<main>",
                                       accel_group);
  gtk_item_factory_create_items(item_factory, nmenu_items, menu_items, NULL);
  gtk_accel_group_attach (accel_group, GTK_OBJECT (window));
  if (menubar)
    *menubar = gtk_item_factory_get_widget(item_factory, "<main>");
}
/**************************************************/
void SelectFontShell(GtkWidget * w, gpointer data)
{
gdk_window_get_origin (window->window,&x,&y);
if (!fontdialog) {
fontdialog=gtk_font_selection_dialog_new ("Font Selection Dialog");
gtk_signal_connect (GTK_OBJECT (fontdialog), "destroy",
                    GTK_SIGNAL_FUNC (FontSelectCancelCB),
                    GTK_OBJECT (fontdialog));
gtk_signal_connect (GTK_OBJECT (fontdialog), "delete_event",
                    GTK_SIGNAL_FUNC (FontSelectCancelCB),
                    GTK_OBJECT (fontdialog));
gtk_signal_connect(GTK_OBJECT(GTK_FONT_SELECTION_DIALOG(fontdialog)->ok_button),
                  "clicked", GTK_SIGNAL_FUNC(FontSelectionOkCB),
                    fontdialog);
gtk_signal_connect(GTK_OBJECT(GTK_FONT_SELECTION_DIALOG(fontdialog)->cancel_button),
                         "clicked",
                         GTK_SIGNAL_FUNC (FontSelectCancelCB),
                         GTK_OBJECT (fontdialog));
gtk_widget_set_uposition (fontdialog, x, y);

  }
  if (!GTK_WIDGET_VISIBLE (fontdialog))
    gtk_widget_show (fontdialog);
}
/*******************************************/
void FontSelectCancelCB( GtkWidget *widget, gpointer data )
{
gtk_widget_destroy(fontdialog);
fontdialog=NULL;
}
/********************************************/
void
FontSelectionOkCB(GtkWidget * w, GtkWidget* fd)
{
  GtkStyle *style;
  gchar     *fontname;

fontname=gtk_font_selection_dialog_get_font_name(GTK_FONT_SELECTION_DIALOG(fd));

if (text)
  {

font=gtk_font_selection_dialog_get_font(GTK_FONT_SELECTION_DIALOG(fd));
  if (font)
     {

     style = gtk_style_copy (gtk_widget_get_style (text));
     gdk_font_unref (style->font);
     style->font = font;
     gdk_font_ref (style->font);
     gtk_widget_set_style (text, style);

	if(keywin){
   	style = gtk_style_copy (gtk_widget_get_style (keywin));
     	gdk_font_unref (style->font);
     	style->font = font;
     	gdk_font_ref (style->font);
     	gtk_widget_set_style (keywin, style);
	SetStyleRecursively (keywin,style);
	}

     }
  }/* fixme */
gtk_widget_destroy(fontdialog);
fontdialog=NULL;
}
/**************************************************/
void FileSelectShell(GtkWidget *fileselect)
{
gdk_window_get_origin (window->window,&x,&y);
if (!fileselect) {
fileselect = gtk_file_selection_new ("File selection");
g_return_if_fail(GTK_IS_FILE_SELECTION(fileselect));
gtk_signal_connect (GTK_OBJECT (fileselect), "destroy",
                  GTK_SIGNAL_FUNC(gtk_widget_destroy), fileselect);
gtk_signal_connect (GTK_OBJECT (fileselect), "delete_event",
                  GTK_SIGNAL_FUNC(gtk_widget_destroy), fileselect);
gtk_signal_connect (GTK_OBJECT (GTK_FILE_SELECTION (fileselect)->ok_button),
                        "clicked", GTK_SIGNAL_FUNC(FileSelectionOkCB),
                         fileselect );
gtk_signal_connect_object (GTK_OBJECT (GTK_FILE_SELECTION (fileselect)->cancel_button),
                               "clicked", GTK_SIGNAL_FUNC(gtk_widget_destroy),
                               GTK_OBJECT (fileselect));
gtk_widget_set_uposition (fileselect, x, y);
gtk_widget_show(fileselect);
}
}
/********************************************/
void
FileSelectionOkCB(GtkWidget * w, GtkFileSelection *fs)
{
char *tempstr;
struct stat sb;
tempstr=gtk_file_selection_get_filename (GTK_FILE_SELECTION (fs));

if(tempstr==NULL)return;
if(stat(tempstr, &sb) == -1) return;
if (S_ISDIR(sb.st_mode))return;

if((strcmp(filename,DefFileName)!=0)||(FileModified==TRUE)){
sprintf(strbus, "%s  %s&", progname,tempstr);
system(strbus);
}else{
strcpy(filename,tempstr);
OpenFile(text, tempstr);
FileModified=FALSE;
}
gtk_widget_destroy (GTK_WIDGET(fs));
}
/********************************************/
gint OpenFile(GtkWidget *text, gchar *fname)
{
FILE *infile;
GtkStyle *style;
 infile = fopen(fname, "r");

  if (infile) {

    char buffer[1024];
    int nchars;

style = gtk_style_copy (gtk_widget_get_style (text));

gtk_rtext_freeze (GTK_RTEXT (text));
    while (1)
      {
        nchars = fread(buffer, 1, 1024, infile);
        gtk_rtext_insert (GTK_RTEXT (text), style->font, NULL,
                         NULL, buffer, nchars);

        if (nchars < 1024)
          break;
      }

    fclose (infile);
  }

gtk_rtext_thaw (GTK_RTEXT (text));
strcpy(filename,fname);
return 0;
}
/**************************************************/
void BGColorSelectShell()
{

gdk_window_get_origin (window->window,&x,&y);

if (!colorseld) {

colorseld=gtk_color_selection_dialog_new("Select background color");
gtk_signal_connect (GTK_OBJECT (colorseld), "destroy",
                  GTK_SIGNAL_FUNC(ChangeColorCancelCB), colorseld);
gtk_signal_connect (GTK_OBJECT (colorseld), "delete_event",
                  GTK_SIGNAL_FUNC(ChangeColorCancelCB), colorseld);

colorsel=GTK_COLOR_SELECTION_DIALOG(colorseld)->colorsel;
gtk_color_selection_set_update_policy(GTK_COLOR_SELECTION(colorsel),
                                        GTK_UPDATE_DISCONTINUOUS);
gtk_signal_connect_object(GTK_OBJECT(GTK_COLOR_SELECTION_DIALOG(colorseld)->cancel_button),
                               "clicked", GTK_SIGNAL_FUNC(ChangeColorCancelCB),
                               GTK_OBJECT (colorseld));
gtk_widget_set_uposition (colorseld, x, y);
gtk_signal_connect_object (GTK_OBJECT (GTK_COLOR_SELECTION_DIALOG(colorseld)->ok_button),
                               "clicked", GTK_SIGNAL_FUNC(BGColorChangedCB),
                               GTK_OBJECT (colorsel));
}
gtk_widget_show(colorseld);
}
/**************************************************/
void FGColorSelectShell()
{

gdk_window_get_origin (window->window,&x,&y);

if (!colorseld) {

colorseld=gtk_color_selection_dialog_new("Select background color");
gtk_signal_connect (GTK_OBJECT (colorseld), "destroy",
                  GTK_SIGNAL_FUNC(ChangeColorCancelCB), colorseld);
gtk_signal_connect (GTK_OBJECT (colorseld), "delete_event",
                  GTK_SIGNAL_FUNC(ChangeColorCancelCB), colorseld);

colorsel=GTK_COLOR_SELECTION_DIALOG(colorseld)->colorsel;
gtk_color_selection_set_update_policy(GTK_COLOR_SELECTION(colorsel),
                                        GTK_UPDATE_DISCONTINUOUS);
gtk_signal_connect_object(GTK_OBJECT(GTK_COLOR_SELECTION_DIALOG(colorseld)->cancel_button),
                               "clicked", GTK_SIGNAL_FUNC(ChangeColorCancelCB),
                               GTK_OBJECT (colorseld));
gtk_widget_set_uposition (colorseld, x, y);
gtk_signal_connect_object (GTK_OBJECT (GTK_COLOR_SELECTION_DIALOG(colorseld)->ok_button),
                               "clicked", GTK_SIGNAL_FUNC(FGColorChangedCB),
                               GTK_OBJECT (colorsel));
}
gtk_widget_show(colorseld);
}
/*******************************************/
void ChangeColorCancelCB( GtkWidget *widget, gpointer data )
{
gtk_widget_destroy(colorseld);
colorseld=NULL;
}
/****************************************/
void BGColorChangedCB(GtkWidget *widget,gpointer data) 
{
gdouble color[3];
GdkColor gdk_color;
GdkColormap *colormap;
GtkStyle        *style;
colormap = gdk_window_get_colormap (text->window);
/* Get current color */
gtk_color_selection_get_color (GTK_COLOR_SELECTION(colorsel),color);
gdk_color.red = (guint16)(color[0]*65535.0);
gdk_color.green = (guint16)(color[1]*65535.0);
gdk_color.blue = (guint16)(color[2]*65535.0);
/* Allocate color */
gdk_color_alloc (colormap, &gdk_color);
style = gtk_style_copy(gtk_widget_get_style (text));
style->base[GTK_STATE_NORMAL]=gdk_color;
gtk_widget_set_style (text, style);
gtk_widget_destroy(colorseld);
colorseld=NULL;
}
/****************************************/
void FGColorChangedCB(GtkWidget *widget,gpointer data)
{
gdouble color[3];
GdkColor gdk_color;
GdkColormap *colormap;
GtkStyle        *style;
colormap = gdk_window_get_colormap (text->window);
/* Get current color */
gtk_color_selection_get_color (GTK_COLOR_SELECTION(colorsel),color);
gdk_color.red = (guint16)(color[0]*65535.0);
gdk_color.green = (guint16)(color[1]*65535.0);
gdk_color.blue = (guint16)(color[2]*65535.0);
/* Allocate color */
gdk_color_alloc (colormap, &gdk_color);
style = gtk_style_copy(gtk_widget_get_style (text));
style->text[GTK_STATE_NORMAL]=gdk_color;
gtk_widget_set_style (text, style);
gtk_widget_destroy(colorseld);
colorseld=NULL;
}
/****************************************/
void MyBoard(gchar* msg){

 if(winboard!=NULL)
 {
 if(GTK_IS_WIDGET(winboard)) gtk_widget_destroy(winboard);
 }
 winboard=gtk_dialog_new();
gtk_widget_set_usize (GTK_WIDGET (winboard), strlen(msg)+400, 120);

gtk_signal_connect (GTK_OBJECT (winboard), "destroy",
GTK_SIGNAL_FUNC(MyBoardCB), winboard);
gtk_signal_connect (GTK_OBJECT (winboard), "delete_event",
GTK_SIGNAL_FUNC(MyBoardCB), winboard);
gtk_window_set_title (GTK_WINDOW (winboard), windowTitle);
gtk_container_border_width (GTK_CONTAINER (winboard), 0);
gtk_widget_realize(winboard);
gdk_window_get_origin (window->window,&x,&y);
gtk_widget_set_uposition (winboard, x, y);

label = gtk_label_new (msg);
gtk_box_pack_start (GTK_BOX (GTK_DIALOG (winboard)->vbox),
 		label, TRUE, TRUE, 0);
gtk_widget_show (label);

button = gtk_button_new_with_label ("OK");
gtk_signal_connect_object (GTK_OBJECT (button), "clicked",
GTK_SIGNAL_FUNC(MyBoardCB), GTK_OBJECT (winboard));
gtk_box_pack_start (GTK_BOX (GTK_DIALOG (winboard)->action_area),
  button, TRUE, TRUE, 0);
GTK_WIDGET_SET_FLAGS (button, GTK_CAN_DEFAULT);
gtk_widget_grab_default (button);
gtk_widget_show (button);
gtk_widget_show (winboard);
}
/*******************************************/
void MyBoardCB(GtkWidget *widget, gpointer data)
{
 gtk_widget_destroy(winboard);
}
/*******************************************/
void SaveAsOkCB( GtkWidget *widget, GtkFileSelection *fs )
{
FILE    *fd;
char* tempfile;
char* tempstr;
struct stat sb;

tempfile=gtk_file_selection_get_filename (GTK_FILE_SELECTION (fs));

if(tempfile==NULL)return;

tempstr=gtk_editable_get_chars(GTK_EDITABLE (text), 0,
                 gtk_rtext_get_length(GTK_RTEXT(text)));
fd=fopen(tempfile,"w");
if(fd==NULL){
MyBoard("Saving failed\nCan't open file for writing");
g_free(tempstr);
return;
}

fputs((char *)tempstr,fd);
if(fd!=NULL) fclose(fd);
FileModified =FALSE ;

strcpy(filename,tempfile);
g_free(tempstr);
gtk_widget_destroy(winsave);
winsave=NULL;
}
/*******************************************/
void SaveAsCancelCB( GtkWidget *widget, gpointer data )
{
gtk_widget_destroy(winsave);
winsave=NULL;
}
/*******************************************/
void CreateKeyboardCB(GtkWidget *widget, gpointer data)
{
KeyBoard(texttable);
}
/*******************************************/
void KeyBoard(GtkWidget *w)
{
int i,j,m,n;

if(keywin!=NULL)gtk_widget_destroy(keywin);
keywin = gtk_vbox_new (FALSE,0);
gtk_table_attach (GTK_TABLE (w), keywin, 0, 1, 1, 2,
                    GTK_EXPAND | GTK_SHRINK | GTK_FILL,
                    GTK_EXPAND | GTK_SHRINK | GTK_FILL, 0, 0);

for(j=0; j<=5; j++)
{
rows[j] = gtk_hbox_new (FALSE,0);
}
/*************************/
m=160;
for(j=0; j<5; j++)
{
for(i=0; i<19; ++i)
{
n=j*19+i;
ch[n][1]='\0';
ch[n][0]=m;
keys[n]=gtk_button_new_with_label(ch[n]);
gtk_signal_connect(GTK_OBJECT (keys[n]), "clicked",
         GTK_SIGNAL_FUNC (PrintKeyboard), ch[n]);
gtk_box_pack_start(GTK_BOX(rows[j]), keys[n], FALSE, FALSE,0);
gtk_widget_show (keys[n]);
++m;
}
}
for(j=0; j<=5; j++)
{
gtk_box_pack_start(GTK_BOX(keywin), rows[j], FALSE, FALSE, 0);
gtk_widget_show (rows[j]);
}

button=gtk_button_new_with_label("Close Keyboard");
gtk_signal_connect(GTK_OBJECT (button), "clicked",
         GTK_SIGNAL_FUNC (KeyboardDismisCB), keywin);
gtk_box_pack_start(GTK_BOX(rows[5]), button, FALSE, FALSE,0);

gtk_widget_show (button);
gtk_widget_show (keywin);
SetStyleRecursively (keywin, NewStyle(font));
}
/**********************************/
GtkStyle *NewStyle (GdkFont *f)
{
    GtkStyle *style;
    GtkStyle *defstyle;
    defstyle = gtk_widget_get_default_style ();
    style = gtk_style_copy (defstyle);
    style->font = f;
    return (style);
}
/**********************************/
void SetStyleRecursively (GtkWidget *widget, gpointer data)
{
    GtkStyle *style;
    style = (GtkStyle *) data;
    gtk_widget_set_style (widget, style);
    if (GTK_IS_CONTAINER (widget)) {
        gtk_container_foreach (GTK_CONTAINER (widget),
                           SetStyleRecursively, style);
    }
}

/*****************************************/
void KeyboardDismisCB(GtkWidget *widget, gpointer data)
{
gtk_widget_destroy(keywin);
keywin=NULL;
}
/*****************************************/
void PrintKeyboard (GtkWidget *widget, gchar* data)
{
if(FileModified==FALSE)FileModified=TRUE;

gtk_rtext_insert(GTK_RTEXT(text), NULL, NULL, NULL,
                               data, strlen(data));
}
/*****************************************/
void AboutCB(GtkWidget *widget, gpointer data)
{
GtkWidget *myvbox;
GtkWidget *mylabel;
GtkWidget *mybutton;
if(aboutwin!=NULL)gtk_widget_destroy(aboutwin);
aboutwin = gtk_window_new (GTK_WINDOW_POPUP);
gtk_signal_connect (GTK_OBJECT (aboutwin), "destroy",
GTK_SIGNAL_FUNC(AboutCancelCB), aboutwin);
gtk_signal_connect (GTK_OBJECT (aboutwin), "delete_event",
GTK_SIGNAL_FUNC(AboutCancelCB), aboutwin);
gtk_window_set_title (GTK_WINDOW (aboutwin), "About");
gtk_container_border_width (GTK_CONTAINER (aboutwin), 2);
gdk_window_get_origin (window->window,&x,&y);
gtk_widget_set_uposition (aboutwin, x, y);
gtk_widget_set_usize (aboutwin, 300, 230);
myvbox = gtk_vbox_new (FALSE, 0);
gtk_container_add (GTK_CONTAINER (aboutwin), myvbox);
icon = gdk_pixmap_create_from_xpm_d (window->window, &mask,
              &window->style->white, about_xpm );
mylabel = gtk_pixmap_new (icon, mask );
gtk_box_pack_start (GTK_BOX (myvbox), mylabel, TRUE, TRUE, 0);
gtk_widget_show (mylabel);
 mybutton = gtk_button_new_with_label ("Close");
 gtk_signal_connect_object (GTK_OBJECT (mybutton), "clicked",
 GTK_SIGNAL_FUNC(AboutCancelCB), GTK_OBJECT (aboutwin));
 gtk_box_pack_start (GTK_BOX (myvbox), mybutton, TRUE, TRUE, 0);
 gtk_widget_show (mybutton);
 gtk_widget_show (myvbox);
 gtk_widget_show (aboutwin);
}
/**********************************************/
void AboutCancelCB(GtkWidget *widget, gpointer data)
{
gtk_widget_destroy (GTK_WIDGET (aboutwin));
aboutwin=NULL;
}
/**********************************************/
void CleanTextBuffer()
{
gtk_rtext_set_point(GTK_RTEXT(text), 0);
gtk_rtext_forward_delete(GTK_RTEXT(text),
gtk_rtext_get_length(GTK_RTEXT(text)));
}
/**********************************************/
void CloseMakeSureDialog()
{
GtkWidget *dialogwin;
GtkWidget *label;
GtkWidget *button;
gchar   msg1[]="Save";
gchar   msg2[]="Yes";
gchar   msg3[]="Cancel";

dialogwin=gtk_dialog_new ();
gtk_signal_connect (GTK_OBJECT (dialogwin), "destroy",
                        GTK_SIGNAL_FUNC (CancelDialogCB),
                        dialogwin);
gtk_window_set_title(GTK_WINDOW (dialogwin), "Warning!");
gtk_container_border_width (GTK_CONTAINER (dialogwin), 5);
gdk_window_get_origin (window->window,&x,&y);
gtk_widget_set_uposition (dialogwin, x, y);

label = gtk_label_new ("The application was modified, Are you sure you want to CLOSE?");
gtk_misc_set_padding(GTK_MISC(label), 10, 10);
gtk_box_pack_start (GTK_BOX (GTK_DIALOG (dialogwin)->vbox),
                        label, TRUE, TRUE, 0);
gtk_widget_show (label);
/****************************/
button = gtk_button_new_with_label (msg1);

gtk_signal_connect (GTK_OBJECT (button), "clicked",
                        GTK_SIGNAL_FUNC (SaveDialogCB),
                        dialogwin);

 gtk_box_pack_start (GTK_BOX (GTK_DIALOG (dialogwin)->action_area),
                          button, TRUE, TRUE, 0);
gtk_widget_show (button);
/****************************/
button = gtk_button_new_with_label (msg2);

gtk_signal_connect (GTK_OBJECT (button), "clicked",
                        GTK_SIGNAL_FUNC (DontSaveDialogCB),
                        dialogwin);

gtk_box_pack_start (GTK_BOX (GTK_DIALOG (dialogwin)->action_area),
                          button, TRUE, TRUE, 0);
gtk_widget_show (button);
/****************************/
button = gtk_button_new_with_label (msg3);

gtk_signal_connect (GTK_OBJECT (button), "clicked",
                        GTK_SIGNAL_FUNC (CancelDialogCB),
                        dialogwin);
gtk_box_pack_start (GTK_BOX (GTK_DIALOG (dialogwin)->action_area),
                          button, TRUE, TRUE, 0);
gtk_widget_show (button);

gtk_widget_show (dialogwin);
}
/********************************/
void SaveDialogCB(GtkWidget *widget, gpointer data)
{
gtk_widget_destroy (GTK_WIDGET (data));
SaveFileCB(window,NULL );
}
/********************************/
void DontSaveDialogCB(GtkWidget *widget, gpointer data)
{
CleanTextBuffer();
FileModified=FALSE;
strcpy(filename,DefFileName);
gtk_widget_destroy (GTK_WIDGET (data));
}
/********************************/
void CancelDialogCB(GtkWidget *widget, gpointer data)
{
    gtk_widget_destroy (GTK_WIDGET (data));
}
/**********************************************/
void QuitMakeSureDialog()
{
GtkWidget *dialogwin;
GtkWidget *label;
GtkWidget *button;
gchar   msg1[]="Save";
gchar   msg2[]="Yes";
gchar   msg3[]="Cancel";

dialogwin=gtk_dialog_new ();
gtk_signal_connect (GTK_OBJECT (dialogwin), "destroy",
                        GTK_SIGNAL_FUNC (QCancelDialogCB),
                        dialogwin);
gtk_window_set_title(GTK_WINDOW (dialogwin), "Warrning!");
gtk_container_border_width (GTK_CONTAINER (dialogwin), 5);
gdk_window_get_origin (window->window,&x,&y);
gtk_widget_set_uposition (dialogwin, x, y);

label = gtk_label_new ("The application was modified, Are you sure you want to QUIT?");
gtk_misc_set_padding(GTK_MISC(label), 10, 10);
gtk_box_pack_start (GTK_BOX (GTK_DIALOG (dialogwin)->vbox),
                        label, TRUE, TRUE, 0);
gtk_widget_show (label);
/****************************/
button = gtk_button_new_with_label (msg1);

gtk_signal_connect (GTK_OBJECT (button), "clicked",
                        GTK_SIGNAL_FUNC (QSaveDialogCB),
                        dialogwin);

 gtk_box_pack_start (GTK_BOX (GTK_DIALOG (dialogwin)->action_area),
                          button, TRUE, TRUE, 0);
gtk_widget_show (button);
/****************************/
button = gtk_button_new_with_label (msg2);

gtk_signal_connect (GTK_OBJECT (button), "clicked",
                        GTK_SIGNAL_FUNC (QDontSaveDialogCB),
                        dialogwin);

gtk_box_pack_start (GTK_BOX (GTK_DIALOG (dialogwin)->action_area),
                          button, TRUE, TRUE, 0);
gtk_widget_show (button);
/****************************/
button = gtk_button_new_with_label (msg3);

gtk_signal_connect (GTK_OBJECT (button), "clicked",
                        GTK_SIGNAL_FUNC (QCancelDialogCB),
                        dialogwin);
gtk_box_pack_start (GTK_BOX (GTK_DIALOG (dialogwin)->action_area),
                          button, TRUE, TRUE, 0);
gtk_widget_show (button);
gtk_widget_show (dialogwin);
}
/********************************/
void QSaveDialogCB(GtkWidget *widget, gpointer data)
{
gtk_widget_destroy (GTK_WIDGET (data));
SaveFileCB(window,NULL );
}
/********************************/
void QDontSaveDialogCB(GtkWidget *widget, gpointer data)
{
gtk_widget_destroy (GTK_WIDGET (data));
gtk_main_quit();
}
/********************************/
void QCancelDialogCB(GtkWidget *widget, gpointer data)
{
 gtk_widget_destroy (GTK_WIDGET (data));
}
/*******************************************************/
void Right2LeftCB( GtkWidget *widget, gpointer data )
{
gtk_rtext_set_reflected (GTK_RTEXT (text),TRUE);
}
/*******************************************************/
void Left2RightCB( GtkWidget *widget, gpointer data )
{
gtk_rtext_set_reflected (GTK_RTEXT (text),FALSE);
}
/*******************************************************/

